/**********************************************************************

	--- Dlgedit generated file ---

	File: ViewCd.h
	Last generated: Sat Nov 8 20:25:42 1997

 *********************************************************************/

#ifndef ViewCd_included
#define ViewCd_included

#include "ViewCdData.h"
#include <qstrlist.h>
#include <qdir.h>
#include <qclipbrd.h> 

#ifdef DEBUG
#ifdef _WIN32
#define DEBUG_WIN
#endif
#endif

#ifdef DEBUG_WIN
#include "debugwin/DebugWin.h"
#endif

#define TRANS_TBL "TRANS.TBL"
#define CLIP_MAGIC "ViewCd\n"

class ViewCd : public ViewCdData
{
    Q_OBJECT

public:

    ViewCd
    (
        QWidget* parent = NULL,
        const char* name = NULL
    );
    
    ViewCd(QString );// constructor with start_dir

    virtual ~ViewCd();
    
    void set_dir(QString ); // to set current dir
    
    
signals:

	void quit();
	
public slots:

// file menu slots
	void new_window();
	void open();
   	void rescan(); // scans the current directory
	void close();
	void exit();

// help menu slots	
	void about();

// edit menu slots	
	void copy_selected_files();
	void paste();
	void select_all();
	void invert_select();

// edit list click slots	
	void dir_selected(int);
	void file_selected(int);
	
// clipboard slot
	void clip_changed();	
	
private:

	QString current_dir;
	
	// = 1 if we have a TRANS.TBL in the current directory
	int have_trans;
	
	QStrList cd_names;// from the TRANS.TBL file 
	QStrList real_names;
	
	void read_trans();
	void parse_trans(QString);
	
	void translate(QStrList &);
	
	void untranslate(QString &);
	
	int cmp_names(QString,QString);
	
	void init(QString);
	
	QPopupMenu *edit_menu;
	int paste_item; // item number of paste on edit menu	
	
	QClipboard *clip;
	
	void out(QString);
	
	void get_drives(); // fills drives_list
	
	QStrList drives_list; // list of drives if WIN32
	
#ifdef DEBUG_WIN
	DebugWin *debug_win;
#endif	

};
#endif // ViewCd_included
